/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cviceni06;

/**
 *
 * @author Kuba
 */
public class ProducentKonzument{

    public static void main(String[] args) throws Exception{
        Fronta f = new Fronta();
        Vydavatel v = new Vydavatel(f);
        Zakaznik z = new Zakaznik(f);
        z.t.join();
        for(int i=0; i<1000; i++)
            System.out.print(".");
        System.out.println("");
    }
}

class Fronta {

    int predavanaHodnota;
    boolean obsazeno = false;

    synchronized int vyjmout() {
        if (!obsazeno) {
            try {
                wait();
            } catch (InterruptedException e) {
                System.out.println("Vyjmout: InterruptedException");
            }
        }
        System.out.print("\nVyjmuto: " + predavanaHodnota);
        obsazeno = false;
        notify();
        return predavanaHodnota;
    }

    synchronized void vlozit(int hodnota) {
        if (obsazeno) {
            try {
                wait();
            } catch (InterruptedException e) {
                System.out.println("Vlozit: InterruptedException");
            }
        }
        this.predavanaHodnota = hodnota;
        obsazeno = true;
        System.out.print("\nVlozeno: " + hodnota);
        notify();
    }
}

class Vydavatel implements Runnable {

    Fronta f;
    Thread t;

    Vydavatel(Fronta f) {
        this.f = f;
        t = new Thread(this, "Vydavatel");
        t.start();
    }

    public void run() {
        for (int i = 0; i < 5; i++) {
            f.vlozit(i);
        }
    }
}

class Zakaznik implements Runnable {

    Fronta f;
    Thread t;

    Zakaznik(Fronta f) {
        this.f = f;
        t = new Thread(this, "Zakaznik");
        t.start();
    }

    public void run() {
        for (int i = 0; i < 5; i++) {
            f.vyjmout();
        }
        System.out.println("");
    }
}
